import { Export } from '@aws-sdk/client-bcm-data-exports';
import { CdkCustomResourceHandler } from 'aws-lambda';
import { CompressionFormat, ExportVersioning } from './data-export-definition.types';
import { TimeUnit } from './report-definition.types';
export interface Cur2ExportParameters {
    readonly ServiceToken: string;
    readonly ExportType: 'COST_AND_USAGE';
    readonly ExportName: string;
    readonly ExportDescription: string;
    readonly S3Bucket: string;
    readonly S3Prefix: string;
    readonly S3Region: string;
    readonly TimeUnit: TimeUnit;
    readonly CompressionFormat: CompressionFormat;
    readonly ExportVersioning: ExportVersioning;
    readonly IncludeResourceIds: string;
    readonly SplitCostAllocationData: string;
    readonly SelectedColumns: string[];
}
export declare const handler: CdkCustomResourceHandler;
export declare const testModules: {
    cur2ExportParametersToExport: (props: Cur2ExportParameters) => Export;
};
