import { BCMDataExportsServiceException as __BaseException } from "./BCMDataExportsServiceException";
export const CompressionOption = {
    GZIP: "GZIP",
    PARQUET: "PARQUET",
};
export const FormatOption = {
    PARQUET: "PARQUET",
    TEXT_OR_CSV: "TEXT_OR_CSV",
};
export const S3OutputType = {
    CUSTOM: "CUSTOM",
};
export const OverwriteOption = {
    CREATE_NEW_REPORT: "CREATE_NEW_REPORT",
    OVERWRITE_REPORT: "OVERWRITE_REPORT",
};
export const FrequencyOption = {
    SYNCHRONOUS: "SYNCHRONOUS",
};
export class InternalServerException extends __BaseException {
    constructor(opts) {
        super({
            name: "InternalServerException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServerException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServerException.prototype);
        this.Message = opts.Message;
    }
}
export class ServiceQuotaExceededException extends __BaseException {
    constructor(opts) {
        super({
            name: "ServiceQuotaExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "ServiceQuotaExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ServiceQuotaExceededException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
        this.ResourceType = opts.ResourceType;
        this.QuotaCode = opts.QuotaCode;
        this.ServiceCode = opts.ServiceCode;
    }
}
export class ThrottlingException extends __BaseException {
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottlingException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ThrottlingException.prototype);
        this.Message = opts.Message;
        this.QuotaCode = opts.QuotaCode;
        this.ServiceCode = opts.ServiceCode;
    }
}
export const ValidationExceptionReason = {
    CANNOT_PARSE: "cannotParse",
    FIELD_VALIDATION_FAILED: "fieldValidationFailed",
    OTHER: "other",
    UNKNOWN_OPERATION: "unknownOperation",
};
export class ValidationException extends __BaseException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
        this.Message = opts.Message;
        this.Reason = opts.Reason;
        this.Fields = opts.Fields;
    }
}
export class ResourceNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.Message = opts.Message;
        this.ResourceId = opts.ResourceId;
        this.ResourceType = opts.ResourceType;
    }
}
export const ExecutionStatusCode = {
    DELIVERY_FAILURE: "DELIVERY_FAILURE",
    DELIVERY_IN_PROCESS: "DELIVERY_IN_PROCESS",
    DELIVERY_SUCCESS: "DELIVERY_SUCCESS",
    INITIATION_IN_PROCESS: "INITIATION_IN_PROCESS",
    QUERY_FAILURE: "QUERY_FAILURE",
    QUERY_IN_PROCESS: "QUERY_IN_PROCESS",
    QUERY_QUEUED: "QUERY_QUEUED",
};
export const ExecutionStatusReason = {
    BILL_OWNER_CHANGED: "BILL_OWNER_CHANGED",
    INSUFFICIENT_PERMISSION: "INSUFFICIENT_PERMISSION",
    INTERNAL_FAILURE: "INTERNAL_FAILURE",
};
export const ExportStatusCode = {
    HEALTHY: "HEALTHY",
    UNHEALTHY: "UNHEALTHY",
};
