import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { CreateExportCommandInput, CreateExportCommandOutput } from "../commands/CreateExportCommand";
import { DeleteExportCommandInput, DeleteExportCommandOutput } from "../commands/DeleteExportCommand";
import { GetExecutionCommandInput, GetExecutionCommandOutput } from "../commands/GetExecutionCommand";
import { GetExportCommandInput, GetExportCommandOutput } from "../commands/GetExportCommand";
import { GetTableCommandInput, GetTableCommandOutput } from "../commands/GetTableCommand";
import { ListExecutionsCommandInput, ListExecutionsCommandOutput } from "../commands/ListExecutionsCommand";
import { ListExportsCommandInput, ListExportsCommandOutput } from "../commands/ListExportsCommand";
import { ListTablesCommandInput, ListTablesCommandOutput } from "../commands/ListTablesCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "../commands/ListTagsForResourceCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateExportCommandInput, UpdateExportCommandOutput } from "../commands/UpdateExportCommand";
/**
 * serializeAws_json1_1CreateExportCommand
 */
export declare const se_CreateExportCommand: (input: CreateExportCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1DeleteExportCommand
 */
export declare const se_DeleteExportCommand: (input: DeleteExportCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetExecutionCommand
 */
export declare const se_GetExecutionCommand: (input: GetExecutionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetExportCommand
 */
export declare const se_GetExportCommand: (input: GetExportCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1GetTableCommand
 */
export declare const se_GetTableCommand: (input: GetTableCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListExecutionsCommand
 */
export declare const se_ListExecutionsCommand: (input: ListExecutionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListExportsCommand
 */
export declare const se_ListExportsCommand: (input: ListExportsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTablesCommand
 */
export declare const se_ListTablesCommand: (input: ListTablesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1ListTagsForResourceCommand
 */
export declare const se_ListTagsForResourceCommand: (input: ListTagsForResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_json1_1UpdateExportCommand
 */
export declare const se_UpdateExportCommand: (input: UpdateExportCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_json1_1CreateExportCommand
 */
export declare const de_CreateExportCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateExportCommandOutput>;
/**
 * deserializeAws_json1_1DeleteExportCommand
 */
export declare const de_DeleteExportCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteExportCommandOutput>;
/**
 * deserializeAws_json1_1GetExecutionCommand
 */
export declare const de_GetExecutionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetExecutionCommandOutput>;
/**
 * deserializeAws_json1_1GetExportCommand
 */
export declare const de_GetExportCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetExportCommandOutput>;
/**
 * deserializeAws_json1_1GetTableCommand
 */
export declare const de_GetTableCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTableCommandOutput>;
/**
 * deserializeAws_json1_1ListExecutionsCommand
 */
export declare const de_ListExecutionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListExecutionsCommandOutput>;
/**
 * deserializeAws_json1_1ListExportsCommand
 */
export declare const de_ListExportsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListExportsCommandOutput>;
/**
 * deserializeAws_json1_1ListTablesCommand
 */
export declare const de_ListTablesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTablesCommandOutput>;
/**
 * deserializeAws_json1_1ListTagsForResourceCommand
 */
export declare const de_ListTagsForResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsForResourceCommandOutput>;
/**
 * deserializeAws_json1_1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_json1_1UpdateExportCommand
 */
export declare const de_UpdateExportCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateExportCommandOutput>;
