import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { BCMDataExportsClientResolvedConfig } from "../BCMDataExportsClient";
export interface BCMDataExportsHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface BCMDataExportsHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    BCMDataExportsClientResolvedConfig,
    HandlerExecutionContext,
    BCMDataExportsHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultBCMDataExportsHttpAuthSchemeParametersProvider: (
  config: BCMDataExportsClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<BCMDataExportsHttpAuthSchemeParameters>;
export interface BCMDataExportsHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<BCMDataExportsHttpAuthSchemeParameters> {}
export declare const defaultBCMDataExportsHttpAuthSchemeProvider: BCMDataExportsHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: BCMDataExportsHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: BCMDataExportsHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
