import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import {
  CreateExportCommandInput,
  CreateExportCommandOutput,
} from "../commands/CreateExportCommand";
import {
  DeleteExportCommandInput,
  DeleteExportCommandOutput,
} from "../commands/DeleteExportCommand";
import {
  GetExecutionCommandInput,
  GetExecutionCommandOutput,
} from "../commands/GetExecutionCommand";
import {
  GetExportCommandInput,
  GetExportCommandOutput,
} from "../commands/GetExportCommand";
import {
  GetTableCommandInput,
  GetTableCommandOutput,
} from "../commands/GetTableCommand";
import {
  ListExecutionsCommandInput,
  ListExecutionsCommandOutput,
} from "../commands/ListExecutionsCommand";
import {
  ListExportsCommandInput,
  ListExportsCommandOutput,
} from "../commands/ListExportsCommand";
import {
  ListTablesCommandInput,
  ListTablesCommandOutput,
} from "../commands/ListTablesCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "../commands/ListTagsForResourceCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "../commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "../commands/UntagResourceCommand";
import {
  UpdateExportCommandInput,
  UpdateExportCommandOutput,
} from "../commands/UpdateExportCommand";
export declare const se_CreateExportCommand: (
  input: CreateExportCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteExportCommand: (
  input: DeleteExportCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetExecutionCommand: (
  input: GetExecutionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetExportCommand: (
  input: GetExportCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetTableCommand: (
  input: GetTableCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListExecutionsCommand: (
  input: ListExecutionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListExportsCommand: (
  input: ListExportsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListTablesCommand: (
  input: ListTablesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ListTagsForResourceCommand: (
  input: ListTagsForResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_TagResourceCommand: (
  input: TagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UntagResourceCommand: (
  input: UntagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateExportCommand: (
  input: UpdateExportCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const de_CreateExportCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateExportCommandOutput>;
export declare const de_DeleteExportCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteExportCommandOutput>;
export declare const de_GetExecutionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetExecutionCommandOutput>;
export declare const de_GetExportCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetExportCommandOutput>;
export declare const de_GetTableCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetTableCommandOutput>;
export declare const de_ListExecutionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListExecutionsCommandOutput>;
export declare const de_ListExportsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListExportsCommandOutput>;
export declare const de_ListTablesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListTablesCommandOutput>;
export declare const de_ListTagsForResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListTagsForResourceCommandOutput>;
export declare const de_TagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TagResourceCommandOutput>;
export declare const de_UntagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UntagResourceCommandOutput>;
export declare const de_UpdateExportCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateExportCommandOutput>;
